// import {Datastore} from '@google-cloud/datastore';
// import express from 'express';
// import cors from 'cors'

const {Datastore} = require('@google-cloud/datastore')
const express = require('express')
const cors = require('cors')

const app = express();
app.use(express.json())
app.use(cors())

const datastore = new Datastore()
// Associate {username:""(unique id), password:""}

app.patch('/users/login',async (req,res)=>{
    const user = req.body;
    //const key = datastore.key(['Employee',employee.Username])// you can specify your OWN ID rather than an autogenerated number id
    //const response = await datastore.save({key:key,data:employee})
    const query = datastore.createQuery('User').filter('email','=',user.email).filter('password','=',user.password);
    const result = await datastore.runQuery(query)
    res.status(201)
    //res.send('Successfully Created a new Employee')
    const fname = (result[0])[0].fname; // how to get array index of an array inside another array and then reference the field
    const lname = (result[0])[0].lname;
    res.json({fname: fname,lname:lname}) // getting 2 names and sending it back
 // res.send(result[0]) // send back employee/user
});

app.get('/users/:email/verify', async(req,res)=>{
    const email = String(req.params.email)
    const query = datastore.createQuery('User').filter('email','=', email)
    const result = await datastore.runQuery(query)
    if(result[0].length === 0) // data comes in [ [user info in json],{other info}] .. so we are checking first index to see if a user exists or not
    {
        res.status(404)
        res.send("No User Found")
    }
    res.status(200)
    res.send("User Found")
})


const PORT = process.env.PORT ||3000;
app.listen(PORT,()=>console.log("Application has started"));